# SPDX-License-Identifier: BSD-3-Clause
#
# Copyright 2025 Raritan Inc. All rights reserved.
#
# This file was generated by IdlC from Smtp.idl.

use strict;

package Raritan::RPC::devsettings::Smtp;

use parent qw(Raritan::RPC::RemoteObject);

use constant typeId => "devsettings.Smtp:1.0.0";

sub new {
    my ($class, $agent, $rid, $typeId) = @_;
    $typeId = $typeId || Raritan::RPC::devsettings::Smtp::typeId;
    return $class->SUPER::new($agent, $rid, $typeId);
}

use Raritan::RPC::devsettings::Smtp::Configuration;

sub getConfiguration($) {
    my ($self) = @_;
    my $agent = $self->{'agent'};
    my $args = {};
    my $rsp = $agent->json_rpc($self->{'rid'}, 'getConfiguration', $args);
    my $_ret_;
    $_ret_ = Raritan::RPC::devsettings::Smtp::Configuration::decode($agent, $rsp->{'_ret_'});
    return $_ret_;
}

use Raritan::RPC::devsettings::Smtp::Configuration;

sub setConfiguration($$) {
    my ($self, $cfg) = @_;
    my $agent = $self->{'agent'};
    my $args = {};
    $args->{'cfg'} = Raritan::RPC::devsettings::Smtp::Configuration::encode($cfg);
    my $rsp = $agent->json_rpc($self->{'rid'}, 'setConfiguration', $args);
}

use Raritan::RPC::devsettings::Smtp::TestResult;
use Raritan::RPC::devsettings::Smtp::Configuration;

sub testConfiguration($$$) {
    my ($self, $cfg, $recipients) = @_;
    my $agent = $self->{'agent'};
    my $args = {};
    $args->{'cfg'} = Raritan::RPC::devsettings::Smtp::Configuration::encode($cfg);
    $args->{'recipients'} = [];
    for (my $i0 = 0; $i0 <= $#{$recipients}; $i0++) {
        $args->{'recipients'}->[$i0] = "$recipients->[$i0]";
    }
    my $rsp = $agent->json_rpc($self->{'rid'}, 'testConfiguration', $args);
    my $_ret_;
    $_ret_ = Raritan::RPC::devsettings::Smtp::TestResult::decode($agent, $rsp->{'_ret_'});
    return $_ret_;
}

Raritan::RPC::Registry::registerProxyClass('devsettings.Smtp', 1, 0, 0, 'Raritan::RPC::devsettings::Smtp');
1;
